/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
'use strict';

const DebugLogFactory = require('./debug-logger');
const { getDefault } = require('../config/options');

// Initialize factory with default values.
// Without `logger.path` this will set Console transport only
const logFactory = new DebugLogFactory({
  agent: {
    logger: {
      level: getDefault('agent.logger.level'),
      append: getDefault('agent.logger.append'),
      stdout: getDefault('agent.logger.stdout')
    }
  }
});

module.exports = function(namespace) {
  return logFactory.make(namespace);
};

/**
 * Initializes the logger factory w/ config. This needs to be called in order to
 * set to use file transports.
 * @param {object} config
 */
module.exports.init = function(config) {
  logFactory.init(config);
};
